﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using StringsComboBoxExample;
using Telerik.Web.UI;

public partial class _Default : System.Web.UI.Page
{
    List<Samples> _samples = null;

    protected void Page_Load(object sender, EventArgs e)
    {
        BindGridData();
    }

    protected void rcb_SampleValues_DataBound(object sender, EventArgs e)
    {
        ((RadComboBox)sender).FindItemByText(((Samples)GetDataItem()).SampleValueString).Selected = true;
    }

    protected void BindGridData()
    {
        _samples = new List<Samples>();
        Samples sample = new Samples();
        sample.Name = "Sample 1";
        sample.SampleValue = SampleValues.SampleValue1;
        sample.SampleValueString = Enum.GetName(typeof(SampleValues), sample.SampleValue);
        _samples.Add(sample);

        Samples sample2 = new Samples();
        sample2.Name = "Sample 2";
        sample2.SampleValue = SampleValues.SampleValue2;
        sample2.SampleValueString = Enum.GetName(typeof(SampleValues), sample2.SampleValue);
        _samples.Add(sample2);

        radGrid.DataSource = _samples.ToArray();
    }

    public static string[] GetSampleValues()
    {
        return Enum.GetNames(typeof(SampleValues));
    }

    protected void Update_Clicked(object sender, EventArgs e)
    {
        Button btn = sender as Button;
        if (btn == null) return;
        List<string> keys = new List<string>(Request.Params.AllKeys);

        string idKey = keys.Find(x => x.EndsWith("hdn_ID"));
        string nameKey = keys.Find(x => x.EndsWith("tbx_Name"));
        string sampleValuesKey = keys.Find(x => x.EndsWith("rcb_SampleValues"));

        Samples sample = new Samples();
        sample.Name = Request.Params[nameKey].Trim();
        sample.SampleValue = (SampleValues)Enum.Parse(typeof(SampleValues), Request.Params[sampleValuesKey]);
        sample.SampleValueString = Enum.GetName(typeof(SampleValues), sample.SampleValue);

        _samples.Add(sample);

        BindGridData();
        radGrid.Rebind();
    }

}


